<?php
namespace Teknisa\COZ\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

class Pla10610Controller extends \Zeedhi\Framework\Controller\Report {

    protected $entityManager;
    protected $birtStrategy;
    protected $pla10610service;
    protected $lista;
    protected $environment;

    public function __construct(ReportService $reportService, $entityManager, $birtStrategy, $pla10610service, $lista, $environment) {
        $this->entityManager = $entityManager;
        $this->birtStrategy = $birtStrategy;
        $this->pla10610service = $pla10610service;
        $this->lista = $lista;
        $this->environment = $environment;

        parent::__construct($reportService);
    }

    protected $reportMapping = array (
    'coz10610' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'DTINICIAL' => 'P_DTINICIAL',
                'DTFINAL' => 'P_DTFINAL',
                'NRORG' => 'P_NRORG',
                'NRLISTACENTRAL' => 'P_NRLISTACENTRAL',
                'NRLISTASERVICO' => 'P_NRLISTASERVICO',
                'CDFILIAL' => 'P_CDFILIAL'
            )
        ),
    'coz10611' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'DTINICIAL' => 'P_DTINICIAL',
                'DTFINAL' => 'P_DTFINAL',
                'NRORG' => 'P_NRORG',
                'NRLISTACENTRAL' => 'P_NRLISTACENTRAL',
                'NRLISTASERVICO' => 'P_NRLISTASERVICO',
                'CDFILIAL' => 'P_CDFILIAL'
            )
        )
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $this->pla10610service->preencheCampos($row);
        $row['NRLISTACENTRAL'] = $this->lista->geraLista($row['CDCENTRAL'], $row['NRORG']);
        $row['NRLISTASERVICO'] = $this->lista->geraListaServico($row['LISTASERVFILI'], $row['NRORG']);
        $row['CDFILIAL'] = $this->environment->getCdFilial();
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
    }  
}